\ Print file from command line or A0:LST.TXT if none
\ Tabs are expanded, *.SCR files are allowed
\ Source text for DX-Forth
\ Pavel Zampach, 2020

    marker TT
$09 constant TAB
 80 value LINELEN \ length of readed line
  0 value FID     \ file ID


: TYPE-TAB \ adr u -- ; print string (adr, u) expanding tabs
  0 ?do
    count dup tab = if
      drop
      8 out @ 7 and - spaces
    else
      emit
    then
  loop   drop
;

: GETNAME \ -- adr u ; get filename
  cmdtail ?dup 0= if
    drop s" A0:LST.TXT"
  else
    2dup s" .SCR" search if 64 to linelen then
    2drop
  then
;

: FILE-CHECK \ ior -- ; test I/O result
  if
    console ." File access error" cr
    abort
  then
;

: MAIN \ -- ; main program entry
  printer
  getname r/o open-file file-check to fid
  begin
    pad linelen fid read-line file-check
  while
    pad swap type-tab cr
  repeat   drop
  fid close-file file-check
  console
;

turnkey main print
